clear all; close all;
tic;

%% Common Condition
ICs1=[0.0;0.5;1.5;2.0;2.5;4.0;6.0;7.5;9.0;10.0];
ICs2=[0.0;0.5;2.0;4.0;6.0;8.0;10.0];
[sICs1,~]=size(ICs1); [sICs2,~]=size(ICs2);

InH1=0.0; % ERK inhibitor IC50=9.0(nM)
InH2=0.0; % Akt inhibitor IC50=0.6(nM)
InH3=0.0; % ErbB receptor inhibitor IC50=30 or 3000(nM)
[~,sInH1]=size(InH1); [~,sInH2]=size(InH2); [~,sInH3]=size(InH3);

%%%%% mcf7.txt
initial(1).name='E'; initial(2).name='H';
proteins=[76 67];
filename='mcf7-1'; identifier='.txt';
time=0:1:1800;
species={}; % species = {'E' 'H'};
parameters={}; % parameters = {'kf48' 'kf47'};

[~,sPro]=size(proteins);

%% DS Calculation
% For new calculation
% DSA_3; 

% For using saved data
% load(sprintf('%s_70IC_InH%0.1f%0.1f%0.1f_ForAnalysis.mat',filename,InH1,InH2,InH3));

%% DS Analysis
[~,sPA]=size(data.InitialCondition{1}.DynamicSensitivity.KineticParameter.value);
[~,sIC]=size(data.InitialCondition);
cFig=1;
line=[{'k-'};{'k--'};{'k-.'}];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% analysis Fig.3AB %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Dynamics of ERK* and Akt*

%%% Setting
initial(1).name='E'; initial(2).name='H';
initial(1).value1=10.0; initial(2).value1=0.0;
initial(1).value2=10.0; initial(2).value2=0.5;
initial(1).value3=10.0; initial(2).value3=10.0;

xRange=[0 1800];
yRange=[0 1.5];
Tit={};

%%% Analysis
s1=length(fieldnames(initial))-1;

opt=1; DSA_2;

for i=1:s1
    initial=rmfield(initial,sprintf('value%d',i));
end
clearvars s1

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% analysis Fig.3C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sustainability of ERK* and Akt*

%%% Setting
xLabel=sprintf('%s(nM)',initial(2).name);
yLabel=sprintf('%s(nM)',initial(1).name);

%%% Analysis
opt=2; DSA_2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% analysis Fig.4 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DS of ERK* and Akt* with respect to the specified parameters

%%% Setting
initial(1).value1=0.5; initial(2).value1=0.5;
para=[27 30 218 231];

xRange=[0 1800];
yRange={};
Tit={};

%%% Analysis
s2=length(fieldnames(initial))-1;

opt=3; DSA_2;

for i=1:s2
    initial=rmfield(initial,sprintf('value%d',i));
end
clearvars s2

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% analysis Fig.5 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Histogram of ERK* and Akt* at 100s, 300s, and 1800s

%%% Setting
t=[100 300 1800]; 
initial(1).value1=0.5; initial(2).value1=0.5;

xLabel='DS';
yLabel='Frequency';
xRange={};
yRange={};
Tit={};

%%% Analysis
s2=length(fieldnames(initial))-1;
opt=4; DSA_2;

for i=1:s2
    initial=rmfield(initial,sprintf('value%d',i));
end
clearvars s2

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% analysis Fig.6 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Critical parameter

%%% Setting
initial(1).value1=0.0; initial(2).value1=10.0; % H,E=0.5,10.0
initial(1).value2=10.0; initial(2).value2=10.0; % H,E=10.0,10.0
initial(1).value3=0.0; initial(2).value3=0.5; % H,E=0.5,0.5
initial(1).value4=10.0; initial(2).value4=0.0; % H,E=10.0,0.5
t=300; % any time you can change at 0s to 1800s
range1=0.25; range2=0.55;

xRange=[0 6.0];
yRange=[0 6.0];

%%% Analysis
s2=length(fieldnames(initial))-1;
opt=5; DSA_2;

for i=1:s2
    initial=rmfield(initial,sprintf('value%d',i));
end
clearvars s2

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% analysis Fig.7 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MPS
%%% Setting
t=[100 300 1800];

xLabel=sprintf('%s(nM)',initial(2).name);
yLabel=sprintf('%s(nM)',initial(1).name);

%%% Analysis
opt=6; DSA_2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% analysis Fig.8 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MPS vs StD,Max,Kurt,Skew

%%% Setting
t=1800;

%%% Analysis
opt=7; DSA_2;

fprintf('%0.2f(sec)\t%0.2f(min)\n',toc,toc/60);
