%% DS Analysis

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Activity Fig.2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if opt==1

[sL1,sL2]=DSInitialCount(initial,ICs1,ICs2);
for i=1:s1
    for j=1:sPro
    dataFig2.protein{j}(:,i)=data.InitialCondition{sICs1*(sL2(i)-1)+sL1(i)}.StateValue(:,j);
    end
end
dataFig2.time=data.time;
dataFig2.StateName=data.StateName;
dataFig2.initial(:,1)=sL1;
dataFig2.initial(:,2)=sL2;

for j=1:sPro
    Max(j)=max(max(dataFig2.protein{j}));
    dataFig2.protein{j}=dataFig2.protein{j}/Max(j);
end

a=3;
b=ceil(s1/a);
for i=1:sPro
    c=3;
    for j=1:b
        if j==b
            c=rem(s1,a);
            if c==0
                c=3;
            end
        end
        
        if j~=1
        cFig=cFig+1;
        end
        
        figure(cFig);
        for k=1:c
        plot(dataFig2.time,dataFig2.protein{i}(:,a*(j-1)+k),char(line(k)),'LineWidth',1.7); hold on;
        end
        if i==1
        DSA_4('Time(s)','ERK*(nM)',xRange,yRange,Tit);
        elseif i==2
        DSA_4('Time(s)','Akt*(nM)',xRange,yRange,Tit);    
        end
        legend('HRG=0.0nM','HRG=0.5nM','HRG=10.0nM');
    end
    cFig=cFig+1;
end


clearvars s2 s3 Max act figc fig sL1 sL2
clearvars row column xRange yRange Tit a b c

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% Sustainability Fig.3 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if opt==2

for i=1:sICs1
    L1(i,1)={num2str(ICs1(i))};
end
for i=1:sPro
    for j=1:sICs2
        L2(sICs2*(i-1)+j,1)={num2str(ICs2(j))};
    end
end

for i=1:sIC
    for j=1:sPro
    dataFig3.protein{j}(:,i)=data.InitialCondition{i}.StateValue(:,j);
    end
end

for i=1:sPro
    Max=max(max(dataFig3.protein{i}));
    for j=1:sIC
    dataFig3.Standardize{i}(:,j)=dataFig3.protein{i}(:,j)./Max;
    end
    dataFig3.Standardize{i}(:,1)=0;
end

for i=1:sICs1
    for j=1:sICs2
        for k=1:sPro
        sustain(i,sICs2*(k-1)+j)=(max(dataFig3.protein{k}(:,sICs1*(j-1)+i))-dataFig3.protein{k}(end,sICs1*(j-1)+i))/max(dataFig3.protein{k}(:,sICs1*(j-1)+i));
        end
    end
end

hmoA=HeatMap(sustain,'Symmetric',1,'Colormap',redgreencmap(11),'RowLabels',L1,'ColumnLabels',L2,'AnnotColor','w'); %,'DisplayRange',0.4
addXLabel(hmoA,'HRG(nM)','FontName','Arial','FontSize',12);
addYLabel(hmoA,'EGF(nM)','FontName','Arial','FontSize',12);

clearvars Max hmoA ans a b c sustain
clearvars Lig1 Lig2 sL1 sL2 L1 L2 xLabel yLabel

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%% Time course Fig.4 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if opt==3

[sL1,sL2]=DSInitialCount(initial,ICs1,ICs2);
[~,s1]=size(para);
for i=1:s1
    for j=1:sPro
    dataFig4.protein{j}(:,i)=data.InitialCondition{sICs1*(sL2(1)-1)+sL1(1)}.RelativeDynamicSensitivity.KineticParameter.value{1,para(i)}(:,j);
    end
end
dataFig4.time=data.time;
dataFig4.ParameterName=data.ParameterName(para(1:s1));
dataFig4.StateName=data.StateName;

a=4;
b=ceil(s1/a);
c=4;
str1='legend('; str2=');'; str3=',';
str4=sprintf('char(dataFig4.StateName(proteins(1)))');
if sPro~=1
for i=2:sPro
    str5=sprintf('char(dataFig4.StateName(proteins(%d)))',i);
    str4=strcat(str4,str3); str4=strcat(str4,str5);
end
end
output=sprintf('%s%s%s',str1,str4,str2);

for j=1:b
    if j==b
    c=rem(s1,a);
        if c==0
            c=4;
        end
    end
        
    figure(cFig);
    for k=1:c
        subplot(2,2,k);
        figure(cFig);
        for i=1:sPro
            plot(dataFig4.time,dataFig4.protein{i}(:,a*(j-1)+k),char(line(i)),'LineWidth',1.0); hold on;
        end
        DSA_4('Time(s)',sprintf('DS(%s)',char(dataFig4.ParameterName(a*(j-1)+k))),xRange,yRange,Tit);
        legend('ERK*','Akt*');
    end
    cFig=cFig+1;
end

clearvars h1 a b c str1 str2 str3 str4 str5 output
clearvars s1 row column xRange yRange Tit

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Histgram Fig.5 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if opt==4

[sL1,sL2]=DSInitialCount(initial,ICs1,ICs2);
[~,s1]=size(t);
for i=1:s2
    for j=1:sPA
        for k=1:sPro
            for l=1:s1
                dataFig5.hist{k}.InitialCondition{i}.value(j,l)= ...
                data.InitialCondition{sICs1*(sL2(i)-1)+sL1(i)}.RelativeDynamicSensitivity.KineticParameter.value{j}(t(l),k);
            end
        end
    end
end
dataFig5.StateName=data.StateName;

str1='hist(['; str2='],nbin);';
str4=sprintf('dataFig5.hist{i}.InitialCondition{j}.value(:,1)');
if sPro~=1
for i=2:s1
    str5=sprintf(' dataFig5.hist{i}.InitialCondition{j}.value(:,%d)',i); 
    str4=strcat(str4,str5);
end
end
output1=sprintf('%s%s%s',str1,str4,str2);

clearvars str1 str2 str3 str4 str5

str1='legend('; str2=');'; str3=','; str4='s';
str5=sprintf('char(strcat(num2str(t(1)),str4))');
if sPro~=1
for i=2:s1
    str6=sprintf('char(strcat(num2str(t(%d)),str4))',i);
    str5=strcat(str5,str3); str5=strcat(str5,str6);
end
end
output2=sprintf('%s%s%s',str1,str5,str2);

nbin=15;
for i=1:sPro
    for j=1:s2
        figure(cFig); cFig=cFig+1;
        eval(output1); eval(output2); h1.FontSize=12; h1.FontName='Arial';
        DSA_4(xLabel,yLabel,xRange,yRange,Tit);
        colormap gray;
    end
end

clearvars nbin criticalpara h1 str1 str2 str3 str4 str5 str6 output1 output2
clearvars s1 row column t sL1 sL2 xLabel yLabel

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% critical parameter Fig.6-7 %%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if opt==5

[sL1,sL2]=DSInitialCount(initial,ICs1,ICs2);
[~,s1]=size(sL1);
for i=1:sPA
    for j=1:s1
    dataFig6_7.InitialCondition{j}.RelativeDynamicSensitivity.KineticParameter.value{i}(:,1:sPro)=data.InitialCondition{sICs1*(sL2(j)-1)+sL1(j)}.RelativeDynamicSensitivity.KineticParameter.value{i}(:,1:sPro);
    end
end
dataFig6_7.ParameterName=data.ParameterName;
dataFig6_7.StateName=data.StateName;

countA(1:s1)=0; countE(1:s1)=0; countAE(1:s1)=0;
para1(1:sPA,1:s1)={[]}; val1(1:sPA,1:s1)=0; num1(1:sPA,1:s1)=0;
para2(1:sPA,1:s1)={[]}; val2(1:sPA,1:s1)=0; num2(1:sPA,1:s1)=0;
para3(1:sPA,1:s1)={[]}; val3(1:sPA,1:s1)=0; num3(1:sPA,1:s1)=0;

for k=1:sPro-1
for i=1:s1
    for j=1:sPA
        DS1=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{j}(t,1);
        DS2=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{j}(t,k+1);
        if abs(DS1) > range1 && abs(DS2) < range2
            countE(i)=countE(i)+1;
            para1(countE(i),i)=dataFig6_7.ParameterName(j);
            num1(countE(i),i)=j;
            val1(countE(i),i)=abs(DS1);
        elseif abs(DS1) >= range1 && abs(DS2) >= range2
            countAE(i)=countAE(i)+1;
            para3(countAE(i),i)=dataFig6_7.ParameterName(j);
            num3(countAE(i),i)=j;
            val3(countAE(i),i)=abs(DS1);
        elseif abs(DS1) < range1 && abs(DS2) > range2
            countA(i)=countA(i)+1;
            para2(countA(i),i)=dataFig6_7.ParameterName(j);
            num2(countA(i),i)=j;
            val2(countA(i),i)=abs(DS2);
        end
    end
end

figure(cFig); cFig=cFig+1;
for i=1:s1
subplot(2,2,i);
if countA(i)~=0
for j=1:countA(i)
DS1=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{num2(j,i)}(t,1);
DS2=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{num2(j,i)}(t,2);
plot(abs(DS1),abs(DS2),'k.','LineWidth',3.0); hold on;
end
end
if countAE(i)~=0
for j=1:countAE(i)
DS1=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{num3(j,i)}(t,1);
DS2=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{num3(j,i)}(t,2);
plot(abs(DS1),abs(DS2),'k.','LineWidth',3.0); hold on;
end
end
if countE(i)~=0
for j=1:countE(i)
DS1=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{num1(j,i)}(t,1);
DS2=dataFig6_7.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{num1(j,i)}(t,2);
plot(abs(DS1),abs(DS2),'k.','LineWidth',3.0); hold on;
end
end

x='DS of ERK*';
y='DS of Akt*';
DSA_4(x,y,xRange,yRange,sprintf('(HRG,EGF)=(%0.1f,%0.1f)',ICs2(sL2(i)),ICs1(sL1(i))));
set(gca,'XTick',0:1:6.0,'YTick',0:1:6.0);

end

end

for i=1:s1
if countA(i)~=0
[IXa,Ba]=sort(val2(1:countA(i),i),'descend');
para2(1:countA(i),i)=para2(Ba,i); val2(1:countA(i),i)=IXa;
end
if countAE(i)~=0
[IXae,Bae]=sort(val3(1:countAE(i),i),'descend');
para3(1:countAE(i),i)=para3(Bae,i); val3(1:countAE(i),i)=IXae;
end
if countE(i)~=0
[IXe,Be]=sort(val1(1:countE(i),i),'descend');
para1(1:countE(i),i)=para1(Be,i); val1(1:countE(i),i)=IXe;
end
end

clearvars countA countE countAE num1 num2 num3 DS1 DS2 IC
clearvars s1 range1 range2 t x y xRange yRange IXa IXae IXe Ba Bae Be

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% MPS Fig.8 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if opt==6

[~,s1]=size(t);
[sL1,~]=size(ICs1);
[sL2,~]=size(ICs2);
for i=1:sL1
    L1(i,1)={num2str(ICs1(i))};
end
for i=1:sPro*s1
    for j=1:sL2
        L2(sL2*(i-1)+j,1)={num2str(ICs2(j))};
    end
end

for i=1:sIC
    for j=1:s1
        for k=1:sPA
        temp(k,:)=data.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{k}(t(j),:).*data.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{k}(t(j),:);
        end
        dataFig8.InitialCondition{i}.MPS(j,:)=sqrt(sum(temp));
    end
end

for i=1:sICs1
    for j=1:sICs2
        for k=1:s1
            for l=1:sPro
            MPS(i,s1*sICs2*(l-1)+sICs2*(k-1)+j)=dataFig8.InitialCondition{sICs1*(j-1)+i}.MPS(k,l);
            end
        end
    end
end

hmoA=HeatMap(MPS,'Symmetric',1,'Colormap',redgreencmap(11),'RowLabels',L1,'ColumnLabels',L2,'AnnotColor','w'); %,'DisplayRange',13
addXLabel(hmoA,'HRG(nM)','FontSize',12);
addYLabel(hmoA,'EGF(nM)','FontSize',12);

clearvars s1 hmoA ans HRG1 temp1 MPS
clearvars temp t sL1 sL2 L1 L2 xLabel yLabel

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% vs MPS Fig.9-10 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if opt==7

for i=1:sIC
    for j=1:sPA
    temp(j,:)=data.InitialCondition{i}.RelativeDynamicSensitivity.KineticParameter.value{j}(t,:);
    end
    dataFig9_10.InitialCondition{i}.MPS(1,:)=sqrt(sum(temp.*temp));
    dataFig9_10.InitialCondition{i}.StD(1,:)=std(temp);
    dataFig9_10.InitialCondition{i}.Kurt(1,:)=kurtosis(temp);
    dataFig9_10.InitialCondition{i}.Skew(1,:)=skewness(temp);
    dataFig9_10.InitialCondition{i}.Max(1,:)=max(temp);
    dataFig9_10.InitialCondition{i}.Ave(1,:)=mean(temp);
end
dataFig9_10.StateName=data.StateName;

temp1=1; figure(cFig); cFig=cFig+1;
for k=1:sPro
if temp1~=ceil(k/2);
figure(cFig); cFig=cFig+1;
temp1=ceil(k/2);
end

for i=1:sIC
        X(1,i)=dataFig9_10.InitialCondition{i}.StD(1,k);
        X(2,i)=dataFig9_10.InitialCondition{i}.Max(1,k);
        Y(1,i)=dataFig9_10.InitialCondition{i}.MPS(1,k);
end

if rem(k,2)==0
    subpl=2;
elseif rem(k,2)==1
    subpl=1;
end

subplot(2,2,subpl);
plot(X(1,:),Y,'k.','LineWidth',1.7); hold on;
if k==1
x=sprintf('St.Dev. of DS of ERK* at %d(s)',t);
y=sprintf('MPS of ERK* at %d(s)',t);
elseif k==2
x=sprintf('St.Dev. of DS of Akt* at %d(s)',t);
y=sprintf('MPS of Akt* at %d(s)',t);   
end
DSA_4(x,y,[0 1],[0 15]);

subplot(2,2,subpl+2);
plot(X(2,:),Y,'k.','LineWidth',1.7); hold on;
if k==1
x=sprintf('Maximum DS of ERK* at %d(s)',t);
y=sprintf('MPS of ERK* at %d(s)',t);
elseif k==2
x=sprintf('Maximum DS of Akt* at %d(s)',t);
y=sprintf('MPS of Akt* at %d(s)',t);   
end
DSA_4(x,y,[0 4.5],[0 15]);

end

temp1=1; figure(cFig); cFig=cFig+1;
for k=1:sPro
if temp1~=ceil(k/2);
figure(cFig); cFig=cFig+1;
temp1=ceil(k/2);
end

for i=1:sIC
        X(3,i)=dataFig9_10.InitialCondition{i}.Kurt(1,k);
        X(4,i)=dataFig9_10.InitialCondition{i}.Skew(1,k);
        Y(1,i)=dataFig9_10.InitialCondition{i}.MPS(1,k);
end

if rem(k,2)==0
    subpl=2;
elseif rem(k,2)==1
    subpl=1;
end

subplot(2,2,subpl);
plot(X(3,:),Y,'k.','LineWidth',1.7); hold on;
if subpl==1 
    DSA_4({},{},[0 60],[0 15]);
elseif subpl==2
    DSA_4({},{},[15 30],[4 12]);
end
x=sprintf('Kurtosis DS of %s at %d(s)',char(dataFig9_10.StateName(proteins(k))),t);
y=sprintf('MPS of %s at %d(s)',char(dataFig9_10.StateName(proteins(k))),t);
DSA_4(x,y);

subplot(2,2,subpl+2);
plot(X(4,:),Y,'k.','LineWidth',1.7); hold on;
if subpl==1
    DSA_4({},{},[0 1.4],[0 15]);
elseif subpl==2
    DSA_4({},{},[0.3 0.9],[4 12]);
end
x=sprintf('Skewness DS of %s at %d(s)',char(dataFig9_10.StateName(proteins(k))),t);
y=sprintf('MPS of %s at %d(s)',char(dataFig9_10.StateName(proteins(k))),t);
DSA_4(x,y);

end

clearvars X Y temp1 subpl
clearvars temp t

end
