function [data] = DSGUI(varargin)
global fh2 fh3 ph2
%% Use system background color for GUI components
panelColor = get(0,'DefaultUicontrolBackgroundColor');
%%
flag1 = 0;
flag2 = 0;

scrsz = get(0,'ScreenSize');
Fsize = [400 300];
fh = figure('Position',[scrsz(3)/3 scrsz(4)/3 Fsize(1) Fsize(2)]);hold on;
set(fh,'Name','Dynamic Sensitivity','NumberTitle','off');
ph1 = uipanel('Parent',fh,'Title','Setting','BackgroundColor',panelColor,...
    'Position', [.03 .001 .95 1]);

%Filename
sth1 = uicontrol(fh, 'Style', 'text','String','Filename:',...
    'Position',[5 Fsize(2)*0.88 100 15],'FontSize', 10,...
    'HorizontalAlignment','left',...
    'Parent', ph1);
eth1 = uicontrol(fh, 'Style', 'edit','Position',[110 Fsize(2)*0.88 220 20],...
    'String','test.txt','HorizontalAlignment','right','Parent', ph1);
%Time
sth2 = uicontrol(fh, 'Style', 'text','String','Time:',...
    'Position',[5 Fsize(2)*0.77 100 15],'FontSize', 10,...
    'HorizontalAlignment','left','Parent', ph1);
eth2 = uicontrol(fh, 'Style', 'edit','Position',[110 Fsize(2)*0.77 220 20],...
    'String','100','HorizontalAlignment','right','Parent', ph1);
%TimeStep
sth3 = uicontrol(fh, 'Style', 'text','String','TimeStep:',...
    'Position',[5 Fsize(2)*0.66 100 15],'FontSize', 10,...
    'HorizontalAlignment','left','Parent', ph1);
eth3 = uicontrol(fh, 'Style', 'edit','Position',[110 Fsize(2)*0.66 220 20],...
    'String','1','HorizontalAlignment','right','Parent', ph1);

%options
sth9_1 = uicontrol(fh, 'Style', 'text',...
    'String','ODE option',...
    'Position',[5 Fsize(2)*0.54 100 15],...
    'FontSize', 10,...
    'HorizontalAlignment','left',...
    'Parent', ph1);
sth9_1 = uicontrol(fh, 'Style', 'text',...
    'String','Reltol:',...
    'Position',[5 Fsize(2)*0.43 100 15],...
    'FontSize', 10,...
    'HorizontalAlignment','left',...
    'Parent', ph1);
sth9_2 = uicontrol(fh, 'Style', 'text',...
    'String','Abstol:',...
    'Position',[5 Fsize(2)*0.32 100 15],...
    'FontSize', 10,...
    'HorizontalAlignment','left',...
    'Parent', ph1);
sth9_3 = uicontrol(fh, 'Style', 'text',...
    'String','Other option:',...
    'Position',[5 Fsize(2)*0.21 100 15],...
    'FontSize', 10,...
    'HorizontalAlignment','left',...
    'Parent', ph1);
sth9_4 = uicontrol(fh, 'Style', 'text',...
    'String','ODE solver:',...
    'Position',[5 Fsize(2)*0.11 100 15],...
    'FontSize', 10,...
    'HorizontalAlignment','left',...
    'Parent', ph1);
eth9_1 = uicontrol(fh, 'Style', 'edit',...
    'Position',[110 Fsize(2)*0.43 220 20],...
    'String','1e-10',...
    'HorizontalAlignment','right',...
    'Parent', ph1);
eth9_2 = uicontrol(fh, 'Style', 'edit',...
    'Position',[110 Fsize(2)*0.32 220 20],...
    'String','1e-10',...
    'HorizontalAlignment','right',...
    'Parent', ph1);
eth9_3 = uicontrol(fh, 'Style', 'edit',...
    'Position',[110 Fsize(2)*0.21 220 20],...
    'HorizontalAlignment','right',...
    'Parent', ph1);
eth9_4 = uicontrol(fh, 'Style', 'edit',...
    'Position',[110 Fsize(2)*0.11 220 20],...
    'String','ode15s',...
    'HorizontalAlignment','right',...
    'Parent', ph1);

bh1 = uicontrol(fh, 'Position', [330 Fsize(2)*0.01 40 30],...
    'String', 'Next>>',...
    'Parent', ph1,...
    'Callback',@button1);
hold off
%% argument setting
if nargin ==1
    
end

    function button1(hObject, eventdata)
        global th1 th2 eth23 sth23 ICflag
        ICflag = 0;
        flag1 = 1;
        model = get(eth1,'String');
        [~,~,extension] = fileparts(model);
        if strcmp(extension,'.xml') || strcmp(extension,'.txt')
            fh2 = figure('Position',[scrsz(3)/3 scrsz(4)/4 650 440]);
            set(fh2,'Name','Dyanamic Sensitivity','NumberTitle','off');
            ph2 = uipanel('Parent',fh2,'Title','Dynamic Sensitivity (DS) Setting','BackgroundColor',panelColor,...
                'Position', [.03 .001 .95 1]);
            
            sth21 = uicontrol(fh2, 'Style', 'text',...
                'String','DS = delta ln(State variable) / delta ln(Independent parameter)',...
                'Position',[20 410 400 15],...
                'FontSize', 10,...
                'HorizontalAlignment','left',...
                'Parent', ph2);
            sth22 = uicontrol(fh2, 'Style', 'text',...
                'String','State variable: Species concentration',...
                'Position',[20 390 400 15],...
                'FontSize', 10,...
                'HorizontalAlignment','left',...
                'Parent', ph2);
            sth24 = uicontrol(fh2, 'Style', 'text',...
                'String','Independent parameter: Constant parameter, Initial concentration',...
                'Position',[20 370 400 15],...
                'FontSize', 10,...
                'HorizontalAlignment','left',...
                'Parent', ph2);
            
            model = SBmodel(model);
            [dat1, ~] = SBparameters(model);
            for i=1:length(dat1)
                Data{i,1} = dat1{i};
                Data{i,2} = false;
            end
            cnames = {'Constant parameters','Available'};
            columnformat = {'char','logical'};
            columneditable = [false true];
            th1 = uitable(fh2,...
                'Data',Data,...
                'ColumnName', cnames,...
                'ColumnFormat',columnformat,...
                'ColumnEditable', columneditable,...
                'Parent', ph2,...
                'RowName',[],...
                'Position', [10 10 190 350]);
        else
            errordlg('File not found','File Error');
        end
        
        flag2 = 1;
        [dat1,~,~] = SBstates(model);
        for i=1:length(dat1)
            Data1{i,1} = dat1{i};
            Data1{i,2} = false;
        end
        cnames = {'Initial concentrations','Available'};
        columnformat = {'char','logical'};
        columneditable = [false true];
        th2 = uitable(fh2,...
            'Data',Data1,...
            'ColumnName', cnames,...
            'ColumnFormat',columnformat,...
            'ColumnEditable', columneditable,...
            'Parent', ph2,...
            'RowName',[],...
            'Position', [210 10 190 350]);
        
        %Initial condition
        sth23 = uicontrol(fh2,...
            'String','IC Setting',...
            'Position',[450 370 100 25],...
            'FontSize', 10,...
            'HorizontalAlignment','left',...
            'Parent', ph2,...
            'Callback',@button3);
        
        eth23 = uicontrol(fh2, 'Style', 'popupmenu',...
            'String',{'1','2','3','4','5'},...
            'Position',[450 410 100 15],...
            'FontSize', 10,...
            'HorizontalAlignment','left',...
            'Parent', ph2);
     
        bh2 = uicontrol(fh2, 'Position', [560 10 40 30],...
            'String', 'Start>>',...
            'Parent', ph2,...
            'Callback',@button2);
    end

    function button2(hObject, eventdata)
        global th1 th2 th3 dat2 ICflag
        model = get(eth1,'String');
        Tend = str2double(get(eth2,'String'));
        Tstep = str2double(get(eth3,'String'));
        timevector = [0:Tstep:Tend];
        option1 = get(eth9_3,'String');
        method = get(eth9_4,'String');
        if isempty(option1) == 1
            options = odeset('Reltol', str2double(get(eth9_1,'String')),'Abstol',str2double(get(eth9_2,'String')));
        else
            [option2, ~] = strsplit(option1,{','});
            option = sprintf('options = odeset(');
            for i=1:length(option2)-1
                option = strcat(option,option2{i},',');
            end
            option = strcat(option,option2{i},');');
            eval(option);
        end
        
        parameters = {};
        pc =1;
        if flag1 == 1
            param = get(th1,'Data');
            for i=1:length(param)
                if param{i,2}==1 % 0
                    parameters{pc} = param{i,1};
                    pc = 1+pc;
                end
            end
        end
        
        species = {};
        pc=1;
        if flag2 == 1
            spe = get(th2,'Data');
            for i=1:length(spe)
                if spe{i,2}==1
                    species{pc} = spe{i,1};
                    pc = 1+pc;
                end
            end
        end
        
        if ICflag==1
            initialTXT = get(th3,'Data');
            [m,n] = size(initialTXT);
            ic=1;
            for i=1:m
                icflag=0;
                for j=2:n
                        initial(i).name = initialTXT(i,1); % ic 
                        eval(sprintf('initial(i).value%d = %e;',j-1,initialTXT{i,j})); % ic
                end
            end
        else
            initial = {};
        end
        
        [data] = DSsensitivity(model, timevector, options, method, species, parameters, {}, initial);
        assignin('base','data',data);
        close;
    end



    function button3(hObject, eventdata)
        global eth23 sth23 dat2 th3 ICflag
        model = get(eth1,'String');
        model = SBmodel(model);
        [dat1,~,dat2] = SBstates(model);
        
        IC = get(eth23,'Value');
        ICflag = get(sth23,'Value');
        
        if ICflag==1
            cnames = {'Species'};
            columnformat = {'char'};
            columneditable(1) = [false];
            for i=1:IC
                cnames{i+1} = sprintf('IC%d',i);
                columnformat{i+1} = 'char';
                columneditable(i+1) = [true];
            end
            for i=1:length(dat1)
                Data{i,1} = dat1{i};
                Data{i,2} = dat2(i);
            end
            for i=2:IC
                for j=1:length(dat1)
                    Data{j,i+1} = Data{j,2};
                end
            end
            th3 = uitable(fh2,...
                'Data',Data,...
                'ColumnName', cnames,...
                'ColumnFormat',columnformat,...
                'ColumnEditable', columneditable,...
                'Parent', ph2,...
                'RowName',[],...
                'Position', [410 10 140 350]);
        end
    end
end
