function [dxdt, dfdx, dfdz] = DScheckdae(varargin)

if length(varargin) == 8
    independent = varargin{1};
    param = varargin{2};
    ic = varargin{3};
    algebraic = varargin{4};
    species = varargin{5};
    spformulas = varargin{6};
    recnames = varargin{7};
    recformulas = varargin{8};
else 
    [independent, param, ic, algebraic, SBMLmodel] = DSparameterReader(filename, {}, {}, {});
    [species, spformulas, recnames, recformulas] = DSGetRateLawsFromReactions(SBMLmodel);
end


[Ndep, Nind, Npar, Nini, GNind, GNpar, GNini] = check_number(independent, param, ic);
DSconvert(independent, param, ic, algebraic, species, spformulas, recnames, recformulas);%ϊ

setenv('SANAC_HOME',pwd);
SANAC_HOME = getenv('SANAC_HOME');
cmdPath = strcat(SANAC_HOME, '\checkdae');

for i=1:2
    file_path = sprintf('\\Convert%d.txt',i);
    in_file_path = strcat(pwd, file_path);
    cmd = strcat(cmdPath ...
        , ' -D', in_file_path ...
        , ' -MATLAB' ...
        );
    [status] = dos(cmd);
    
    if status ~= 0
        Fid = fopen('sys_log.txt');
        tline = fgetl(Fid);
        while ischar(tline)
            fprintf('%s\n',tline);
            tline = fgetl(Fid);
        end
        fclose(Fid);
        error('pde error.');
    end
    
    
    delete('CADLIVE_usr_flux.m');
    delete('CADLIVE_S_usr_fvec.m');
    delete('CADLIVE_S_usr_fjac.m');
    delete('CADLIVE_param.m');
    delete('CADLIVE_initial.m');
    delete('CADLIVE_get_GHnum.m');
    delete('CADLIVE_get_GHdata.m');
    delete('*.tmp');
    
    if i==1;
        dxdt = cell(1,Ndep);
        dfdx=cell(1,Ndep^2);
        for j=1:Ndep^2
            dfdx{j} = '0';
        end
        dfdz = cell(1,Ndep*(Nind+Npar+Nini));
        for j=1:Ndep*(Nind+Npar+Nini) 
            dfdz{j} = '0';
        end
    end
    
    [dxdt, dfdx, dfdz] = DSmodelFormulas(ic, independent, param, i, dxdt, dfdx, dfdz, algebraic, spformulas);
    delete(sprintf('Convert%d.txt',i));
end
delete('CADLIVE_usr_fjac.m');
delete('CADLIVE_usr_fvec.m');