function DSconvert(independent, param, ic, Algebraic, species, Spformulas, recnames, Recformulas)

[Ndep, Nind, Npar, Nini, GNind, GNpar, GNini] = check_number(independent, param, ic);

%% Convert1.txt

spformulas = Spformulas;
recformulas = Recformulas;
algebraic = Algebraic;
[m,n] = size(independent.symbol);
if m>n
    PARAM.symbol = independent.symbol';
    PARAM.value = independent.value';
    PARAM.index = independent.index';
else
    PARAM = independent;
end
for i=1:Npar
    PARAM.symbol(Nind+i) = param.symbol(i);
    PARAM.value(Nind+i) = param.value(i);
    PARAM.index(Nind+i) = param.index(i);
end

for i=1:Npar+Nind
    P(i).name1 = char(PARAM.symbol(i));
    P(i).name2 = strcat(char(PARAM.symbol(i)),'[1]');
    P(i).name3 = P(i).name1;
end
for i=1:Nini
    I(i).name1 = char(ic.symbol(i));
    I(i).name2 = strcat('y[',char(ic.symbol(i)),']');
    I(i).name3 = I(i).name1;
end
for i=1:length(algebraic.name)
    A(i).name1 = char(algebraic.name(i));
    A(i).name2 = strcat(char(algebraic.name(i)),'[1]');
    A(i).name3 = A(i).name1;
end

%recformulas
[recformulas] = convert(recformulas, P, Npar+Nind);
[recformulas] = convert(recformulas, I, Nini);
if ~isempty(algebraic.name)
    [recformulas] = convert(recformulas, A, length(algebraic.name));
end

%spformulas
[spformulas] = convert(spformulas, P, Npar+Nind);
[spformulas] = convert(spformulas, I, Nini);
if ~isempty(algebraic.name)
    [spformulas] = convert(spformulas, A, length(algebraic.name));
end

for i=1:length(spformulas)
    k1 = strfind(spformulas{i}, '+');
    k2 = strfind(spformulas{i}, '(');
    
    if ~isempty(k1) && ~iscell(k1)
        if k1(1)==2
            if ~isempty(k2) && ~iscell(k1)
                if k2(1)==1
                    spformulas{i}(2) = [];
                end
            end
        elseif k1(1)==1
            spformulas{i}(1) = [];
        end
    end
    
    k1 = strfind(spformulas{i}, '0');
    if ~isempty(k1) && ~iscell(k1)
        if k1(1)==1
            spformulas{i}(1) = '1';
        end
    end
end




%% Convert2.txt
recformulas1 = Recformulas;
spformulas1 = Spformulas;
algebraic = Algebraic;

for i=1:Npar+Nind
    P(i).name1 = char(PARAM.symbol(i));
    P(i).name2 = strcat('y[', char(PARAM.symbol(i)),']');
    P(i).name3 = P(i).name1;
end
for i=1:Nini
    I(i).name1 = char(ic.symbol(i));
    I(i).name2 = strcat(char(ic.symbol(i)),'[1]');
    I(i).name3 = I(i).name1;
end
for i=1:length(algebraic.name)
    A(i).name1 = char(algebraic.name(i));
    A(i).name2 = strcat(char(algebraic.name(i)),'[1]');
    A(i).name3 = I(i).name1;
end

[recformulas1] = convert(recformulas1, P, Npar+Nind);
[recformulas1] = convert(recformulas1, I, Nini);
if ~isempty(algebraic.name)
    [recformulas1] = convert(recformulas1, A, length(algebraic.name));
end


%spformulas
[spformulas1] = convert(spformulas1, P, Npar+Nind);
[spformulas1] = convert(spformulas1, I, Nini);
if ~isempty(algebraic.name)
    [spformulas1] = convert(spformulas1, A, length(algebraic.name));
end

for i=1:length(spformulas)
    k1 = strfind(spformulas1{i}, '+');
    k2 = strfind(spformulas1{i}, '(');
    
    if ~isempty(k1)
        if k1(1)==2
            if ~isempty(k2)
                if k2(1)==1
                    spformulas1{i}(2) = [];
                end
            end
        elseif k1(1)==1
            spformulas1{i}(1) = [];
        end
    end
    
    k1 = strfind(spformulas1{i}, '0');
    if ~isempty(k1) && ~iscell(k1)
        if k1(1)==1
            spformulas1{i}(1) = '1';
        end
    end
end
%% Convert1 Generation


Fid = fopen('Convert1.txt','w');
fprintf(Fid, '== Model ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, 'TITLE:Convet model;\r\n');
fprintf(Fid, 'INFO:This is a convert model;\r\n');
fprintf(Fid, 'CONVERSION TYPE\r\n');
fprintf(Fid, '     GENE-PROTEIN:NONE;\r\n');
fprintf(Fid, '     METABOLIC:MM\r\n');


fprintf(Fid, '== Constant Players ==\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '== Variables ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '= Algebraic Equation =\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '= Differencial Equation =\r\n');
fprintf(Fid, '\r\n');
ici = length(ic.symbol);
for i=1:ici
    fprintf(Fid, sprintf('y[%s] = %f;\r\n', char(ic.symbol(i)), ic.value(i)));
end
fprintf(Fid, '\r\n');


fprintf(Fid, '== Used Parameters ==\r\n');
fprintf(Fid, '\r\n');
for i=1:Nind
    fprintf(Fid, sprintf('%s;\r\n', char(independent.symbol(i))));
end
fprintf(Fid, '\r\n');
for i=1:Npar
    fprintf(Fid, sprintf('%s;\r\n', char(param.symbol(i))));
end
for i=1:length(algebraic.name)
    fprintf(Fid, sprintf('%s;\r\n', char(algebraic.name(i))));
end
fprintf(Fid, '\r\n');


fprintf(Fid, '== Parameters ==\r\n');
for i=1:Nind
    fprintf(Fid, sprintf('### %s\r\n', char(independent.symbol(i))));
    fprintf(Fid, sprintf('%s[1] = %f;\r\n', char(independent.symbol(i)), independent.value(i)));
end
for i=1:Npar
    fprintf(Fid, sprintf('### %s\r\n', char(param.symbol(i))));
    fprintf(Fid, sprintf('%s[1] = %f;\r\n', char(param.symbol(i)), param.value(i)));
end
for i=1:length(algebraic.name)
    fprintf(Fid, sprintf('### %s\r\n', char(algebraic.name(i))));
    fprintf(Fid, sprintf('%s[1] = 1.000000;\r\n', char(algebraic.name(i))));
end
fprintf(Fid, '\r\n');

fprintf(Fid, '== Temporary Expressions ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, '= Flux =\r\n');
reci = length(recnames);
for i=1:reci
    fprintf(Fid, sprintf('%s = %s;\r\n', recnames{i}, recformulas{i}));
end
fprintf(Fid, '\r\n');

fprintf(Fid, '== Algebraic Eqs. ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '== Differencial Eqs. ==\r\n');
spi = length(species);
for i=1:spi
    fprintf(Fid, sprintf('dydt[%s] = %s;\r\n', char(species{i}), char(spformulas{i})));
end

fclose(Fid);


%% Convert2 Generation
IC = ic;
[m,n] = size(independent.symbol);
if m>n
    Param.symbol = independent.symbol';
    Param.value = independent.value';
    Param.index = independent.index';
else
    Param = independent;
end
for i=1:Npar
    Param.symbol(Nind+i) = param.symbol(i);
    Param.value(Nind+i) = param.value(i);
    Param.index(Nind+i) = param.index(i);
end
if Nind+Npar < Nini
    for i=Nind+Npar+1:Nini
        Param.symbol{i} = sprintf('P%d',i);
        Param.value(i) = 0;
        Param.index(i) = 0;
    end
elseif Nind+Npar > Nini
    for i=Nini+1:Nind+Npar
        IC.symbol{i} = sprintf('I%d',i);
        IC.value(i) = 0;
        IC.index(i) = 0;
        spformulas1{i} = '1';
    end
end
Fid = fopen('Convert2.txt','w');
fprintf(Fid, '== Model ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, 'TITLE:Convet model;\r\n');
fprintf(Fid, 'INFO:This is a convert model;\r\n');
fprintf(Fid, 'CONVERSION TYPE\r\n');
fprintf(Fid, '     GENE-PROTEIN:NONE;\r\n');
fprintf(Fid, '     METABOLIC:MM\r\n');


fprintf(Fid, '== Constant Players ==\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '== Variables ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '= Algebraic Equation =\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '= Differencial Equation =\r\n');
fprintf(Fid, '\r\n');
for i=1:length(Param.symbol)
    fprintf(Fid, sprintf('y[%s] = %f;\r\n', char(Param.symbol(i)), Param.value(i)));
end
fprintf(Fid, '\r\n');


fprintf(Fid, '== Used Parameters ==\r\n');
fprintf(Fid, '\r\n');
ici = length(ic.symbol);
for i=1:ici
    fprintf(Fid, sprintf('%s;\r\n', char(IC.symbol(i))));
end
for i=1:length(algebraic.name)
    fprintf(Fid, sprintf('%s;\r\n', char(algebraic.name(i))));
end
fprintf(Fid, '\r\n');


fprintf(Fid, '== Parameters ==\r\n');
for i=1:Nini
    fprintf(Fid, sprintf('### %s\r\n',  char(IC.symbol(i))));
    
    if ic.value(i) == 0
        ICv = 1e-6;
    else
        ICv = ic.value(i);
    end
    
    fprintf(Fid, sprintf('%s[1] = %f;\r\n',  char(IC.symbol(i)),  ICv));
end
for i=1:length(algebraic.name)
    fprintf(Fid, sprintf('### %s\r\n', char(algebraic.name(i))));
    fprintf(Fid, sprintf('%s[1] = 1.000000;\r\n', char(algebraic.name(i))));
end
fprintf(Fid, '\r\n');

fprintf(Fid, '== Temporary Expressions ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, '= Flux =\r\n');
reci = length(recnames);
for i=1:reci
    fprintf(Fid, sprintf('%s = %s;\r\n', recnames{i}, recformulas1{i}));
end
fprintf(Fid, '\r\n');

fprintf(Fid, '== Algebraic Eqs. ==\r\n');
fprintf(Fid, '\r\n');
fprintf(Fid, '\r\n');

fprintf(Fid, '\r\n');
fprintf(Fid, '== Differencial Eqs. ==\r\n');
for i=1:length(IC.symbol)
    fprintf(Fid, sprintf('dydt[%s] = %s;\r\n', char(Param.symbol{1,i}), char(spformulas1{i,1})));
end


fclose(Fid);
end

function [formulas] = convert(formulas, R, N)
for i=1:length(formulas)
    for j=1:N
        powflag=0;
        k = strfind(formulas{i}, R(j).name1);
        if ~isempty(k) || ~iscell(k)
            for l=1:length(k)
                C1=0;
                C2=0;
                if k(l)~=1
                    C1 = strcmp(formulas{i}(k(l)-1),'*');
                    if C1==0
                        C1 = strcmp(formulas{i}(k(l)-1),'/');
                        if C1==0
                            C1 = strcmp(formulas{i}(k(l)-1),'+');
                            if C1==0
                                C1 = strcmp(formulas{i}(k(l)-1),'-');
                                if C1==0
                                    C1 = strcmp(formulas{i}(k(l)-1),'(');
                                    if C1==0
                                        C1 = strcmp(formulas{i}(k(l)-1),' ');
                                        if C1==0
                                            C1 = strcmp(formulas{i}(k(l)-1),'^');
                                        end
                                    end
                                end
                            end
                        end
                    end
                elseif k(l)==1
                    C1=1;
                end
                
                lf = k(l)+length(R(j).name1);
                if C1==1 && lf <= length(formulas{i})
                    C2 = strcmp(formulas{i}(lf),'*');
                    if C2==0
                        C2 = strcmp(formulas{i}(lf),'/');
                        if C2==0
                            C2 = strcmp(formulas{i}(lf),'+');
                            if C2==0
                                C2 = strcmp(formulas{i}(lf),'-');
                                if C2==0
                                    C2 = strcmp(formulas{i}(lf),')');
                                    if C2==0
                                        C2 = strcmp(formulas{i}(lf),'^');
                                        if C2==0
                                            C2 = strcmp(formulas{i}(lf),' ');
                                        end
                                    end
                                end
                            end
                        end
                    end
                elseif C1==1 && lf > length(formulas{i})
                    C2=1;
                else
                    C2=0;
                end
                if C1==1 && C2==1
                    formulas{i}(k(l):lf-1) = [];
                    for m=length(formulas{i}):-1:k(l)
                        formulas{i}(m+length(R(j).name2)) = formulas{i}(m);
                    end
                    formulas{i}(k(l):k(l)+length(R(j).name2)-1) = R(j).name2;
                    for n=l:length(k)
                        k(n) = k(n)+length(R(j).name2)-length(R(j).name1);
                    end
                end
            end
        end
    end
end
end
