function [Fname1,Fname2]=DSmakeODEfile(model, Ndep, Nind, Nalg, GN)

S = model.states;
P = model.parameters;
V = model.variables;
R = model.reactions;
F = model.functions;
E = model.events;
clear model;
[tempFname1] = tempnameSB;
[~,Fname1,~] = fileparts(tempFname1);
[tempFname2] = tempnameSB; 
[~,Fname2,~] = fileparts(tempFname2);

    Fid = fopen(sprintf('%s/%s.m',pwd,Fname1),'w');
 
    fprintf(Fid,sprintf('function [dydt] = %s(t,y)\r\n',Fname1));
    fprintf(Fid,sprintf('Ndep = %d;\r\n',Ndep));
    fprintf(Fid,sprintf('dydt = zeros(%d,1);\r\n',Ndep*(GN+1)) );
    
    % parameters
    fprintf(Fid,'%% parameters\r\n');
    for i=1:length(P)
        fprintf(Fid,sprintf('p(%d) = %e;\r\n',i, P(i).value) );
    end
    for i=1:length(P)
        fprintf(Fid,sprintf('%s = p(%d);\r\n', P(i).name,i) );
    end
    
    % ic
    fprintf(Fid,'%% states\r\n');
    for i=1:Ndep
        fprintf(Fid,sprintf('%s = y(%d);\r\n', S(i).name,i) );
    end
    %variable
    fprintf(Fid,'%% variables\r\n');
    for i=1:Nalg
        fprintf(Fid,sprintf('%s = %s;\r\n',V(i).name, V(i).formula) );
    end
    % reactions
    fprintf(Fid,'%% reactions\r\n');
    for i=1:length(R)
        fprintf(Fid,sprintf('%s = %s;\r\n', R(i).name, R(i).formula) );
    end
    
    % M
    fprintf(Fid,'%% M\r\n');
    fprintf(Fid,sprintf('Mjac = zeros(%d,%d);\r\n',Ndep,Ndep));
    c=1;
    for i=1:length(V)
        for j=c:Ndep*Ndep
            if strcmp(V(i).name, sprintf('M%d',j))
                J = rem(j,Ndep);
                I = ceil(j/Ndep);
                if J==0
                    J=Ndep;
                end
                fprintf(Fid,sprintf('Mjac(%d,%d) = %s;\r\n', I, J, V(i).formula) );
                c=j;
                break;
            end
        end
    end
    
    % W
    fprintf(Fid,'%% W\r\n');
    fprintf(Fid,sprintf('Wjac = zeros(1,%d);\r\n',Ndep*GN));
    fprintf(Fid,sprintf('[Wjac] = %s(y,p);\r\n',Fname2));
    
    % sensitivity
    for i=1:GN
        fprintf(Fid,sprintf('dydt(%d*Ndep+1:Ndep*(%d+1),1) = Mjac*y(%d*Ndep+1:Ndep*%d,1)+Wjac(%d*Ndep+1:Ndep*%d)'';\r\n',i,i,i,i+1,i-1,i));
    end
    
    % ODE
    for i=1:Ndep
        fprintf(Fid,sprintf('dydt(%d,1) = %s;\r\n', i, S(i).ODE) );
    end
 
    fprintf(Fid,'end\r\n');
    fclose(Fid);
  


Fid2 = fopen(sprintf('%s/%s.m',pwd,Fname2),'w');
fprintf(Fid2,sprintf('function [Wjac] = %s(y,p)\r\n',Fname2));
fprintf(Fid2,sprintf('Ndep = %d;\r\n',Ndep));
for i=1:length(P)
    fprintf(Fid2,sprintf('%s = p(%d);\r\n', P(i).name,i) );
end

for i=1:Ndep
    fprintf(Fid2,sprintf('%s = y(%d);\r\n', S(i).name,i) );
end
%variable
for i=1:Nalg
    fprintf(Fid2,sprintf('%s = %s;\r\n',V(i).name, V(i).formula) );
end

% W
fprintf(Fid2,sprintf('Wjac = zeros(1,%d);\r\n',Ndep*GN));
c=1;
for i=Nind+1:length(V)
    if strfind(V(i).name, 'dfdz_W')
        for j=c:length(V)
            if strcmp(V(i).name, sprintf('dfdz_W%d',j))
                if ~strcmp(V(i).formula,num2str(0))
                    fprintf(Fid2,sprintf('Wjac(%d) = %s;\r\n',j,V(i).formula) );%Wjac(%d)%ďߕĂH
                    c=j;
                    break;
                end
            end
        end
    end
end

fprintf(Fid2,'end\r\n');
fclose(Fid2);
rehash;
