function [dxdt, dfdx, dfdz] = DSmodelFormulas(ic,independent, param, ConN, dxdt, dfdx, dfdz, algebraic, spformulas)

[Ndep, Nind, Npar, Nini, GNind, GNpar, GNini] = check_number(independent, param, ic);

if ConN==1
    for i=1:length(spformulas)
        dxdt{i} = spformulas{i};
    end
    
    fid = fopen('CADLIVE_usr_fjac.m', 'r');
    tline = fgetl(fid);
    while isempty(strfind(tline, 'fjac( '))
        tline = fgetl(fid);
    end
    
    while ischar(tline)
        k = strfind(tline, '=');
        if ~isempty(k)
            k1 = strfind(tline(1:k), '(');
            k2 = strfind(tline(1:k), ')');
            k3 = strfind(tline(1:k), ',');
            i = str2double(tline(k1+1:k3-1));
            j = str2double(tline(k3+1:k2-1));
            dfdx{(i-1)*Ndep+j} = tline(k+1:end-1);
        end
        tline = fgetl(fid);
    end
    fclose(fid);
        
    for i=1:length(dfdx)
        dfdx{i} = strrep(dfdx{i}, ' ','');
        if ~strcmp(dfdx{i},num2str(0))
            for j=1:Nind
                dfdx{i} = strrep(dfdx{i}, sprintf('%s(1)', independent.symbol{j}), independent.symbol{j});
                if isempty(strfind(dfdx{i},'(1)'))
                    break;
                end
            end
            for j=1:Npar
                dfdx{i} = strrep(dfdx{i}, sprintf('%s(1)', param.symbol{j}), param.symbol{j});
                if isempty(strfind(dfdx{i},'(1)'))
                    break;
                end
            end
            for j=1:Nini
                dfdx{i} = strrep(dfdx{i}, sprintf('y(%d)',j), ic.symbol{j});
                if isempty(strfind(dfdx{i},'y('))
                    break;
                end
            end
            
            for j=1:length(algebraic.name)
                dfdx{i} = strrep(dfdx{i}, sprintf('%s(1)', algebraic.value{j}), algebraic.name{j});
            end
            for j=1:length(algebraic.name)
                dfdx{i} = strrep(dfdx{i}, algebraic.value{j}, algebraic.name{j});
            end
        end
    end
elseif ConN == 2
    fid = fopen('CADLIVE_usr_fjac.m', 'r');
    tline = fgetl(fid);
    while isempty(strfind(tline, 'fjac( '))
        tline = fgetl(fid);
    end
    count=0;
    while ischar(tline)
        k = strfind(tline, '=');
        if ~isempty(k)
            k1 = strfind(tline(1:k), '(');
            k2 = strfind(tline(1:k), ')');
            k3 = strfind(tline(1:k), ',');
            i = str2double(tline(k1+1:k3-1));
            j = str2double(tline(k3+1:k2-1));
            if j<=Nind
                if independent.index(j) == 1
                    dfdz{i+(j-1)*Nini} = tline(k+1:end-1);
                end
            elseif j<=Nind+Npar
                if param.index(j-Nind) == 1
                    if GNind < Nind
                        j=j-Nind+GNind;
                        dfdz{i+(j-1)*Nini} = tline(k+1:end-1);
                    else
                        dfdz{i+(j-1)*Nini} = tline(k+1:end-1);
                        count=count+1;
                    end
                end
            end
        end
        tline = fgetl(fid);
    end
    fclose(fid);

    for i=1:length(dfdz)
        dfdz{i} = strrep(dfdz{i}, ' ','');
        if ~strcmp(dfdz{i},num2str(0))
            for j=1:Nini
                dfdz{i} = strrep(dfdz{i}, sprintf('%s(1)',ic.symbol{j}), ic.symbol{j});
                if isempty(strfind(dfdz{i},'(1)'))
                    break;
                end
            end
            for j=1:Nind
                dfdz{i} = strrep(dfdz{i}, sprintf('y(%d)', j), independent.symbol{j});
                if isempty(strfind(dfdz{i},'y('))
                    break;
                end
            end
            for j=1:Npar
                dfdz{i} = strrep(dfdz{i}, sprintf('y(%d)', j+Nind), param.symbol{j});
                if isempty(strfind(dfdz{i},'y('))
                    break;
                end
            end
            for j=1:length(algebraic.name)
                dfdz{i} = strrep(dfdz{i}, sprintf('%s(1)', algebraic.value{j}), algebraic.name{j});
            end
            for j=1:length(algebraic.name)
                dfdz{i} = strrep(dfdz{i}, algebraic.value{j}, algebraic.name{j});
            end
        end
    end
end

end