function [Ndep, Nind, Npar, Nini, GNind, GNpar, GNini] = check_number(independent, param, ic)
% the function counting the number of dependent, independent and kinetic parameters and initial conditions
% Ndep: number of dependent parameters, Nind: number of independent parameters
% Npar: number of kinetic parameters, Nini: number of initial conditions
% GNind: number of independent parameters for dynamic sensitivity, GNpar: number of kinetic parameters for dynamic sensitivity
% GNini: number of initial conditions for dynamic sensitivity
Ndep=length(ic.symbol);
if isempty(independent.symbol)
        Nind = 0;
        GNind = 0;
else
    Nind=length(independent.symbol);
    GNind = 0;
    for i=1:Nind
        if independent.index(i) == 1
            GNind = GNind+1;
        end
    end
end
Npar=length(param.symbol);
Nini=length(ic.symbol);
GNpar=0;
for i=1:Npar
    if param.index(i)==1
        GNpar = GNpar+1;
    end
end
GNini=0;
for i=1:Nini
    if ic.index(i)==1
        GNini = GNini+1;
    end
end


point = [];
errorflag = 0;
if Npar == 0;
    point = 'parameter';
    errorflag = 2;
end
if Nini == 0;
    point = 'initial condition';
    errorflag = 2;
end
if GNind+GNpar+GNini == 0
    errorflag = 3;
end

errorMsg(point, errorflag);